import java.util.Scanner;

public class ControlloPassword {
		
		// restituisce true se c è lettera maiuscola
		public static boolean isUppercaseChar(char c){
			if (c>='A' && c<='Z') return true;
			else return false;
		}

		// restituisce true se c è lettera minuscola 
		public static boolean isLowercaseChar(char c){
			if (c>='a' && c<='z') return true;
			else return false;
		}
		
		// restituisce true se c è cifra decimale 
		public static boolean isDigit(char c){
			if (c>='0' && c<='9') return true;
			else return false;
		}

		// restituisce true se c è consonante 
		public static boolean isConsonant(char c){
			if (isUppercaseChar(c) && c!='A' && c!='E' && c!='I'&& c!='O' && c!='U') return true;
			else if (isLowercaseChar(c) && c!='a' && c!='e' && c!='i' && c!='o' && c!='u') return true;
			else return false;
		}

		// restituisce true se s è palindroma 
		public static boolean isPal(String s){
			for (int i = 0; i<s.length()/2; i++)
				if (s.charAt(i)!=s.charAt(s.length()-1-i))
					return false;
			return true;
		}

		// restituisce true se TEST 1 è ok 
		public static boolean test1(String s){
		
			if (s.length() >= 5) return true;
			else return false;		
		}

		// restituisce true se TEST 2 è ok 
		public static boolean test2(String s){
			boolean upperCase = false;
			boolean digit = false;
			int i = 0;
			
			while((!digit || !upperCase) & i<s.length()){
				if (!upperCase & isUppercaseChar(s.charAt(i))) upperCase = true;
				if (!digit & isDigit(s.charAt(i))) digit = true;
			i++;
			}

			return (upperCase & digit);
		}

		// restituisce true se TEST 3 è ok 
		public static boolean test3(String s){
			for (int i = 1; i<s.length(); i=i+2)
				if (!isConsonant(s.charAt(i))) return false;
			return true;
		}

		// restituisce true se TEST 4 è ok 
		public static boolean test4(String s){
			String q = "";
			for (int i = 0; i<s.length(); i=i+2)
				q = q + s.charAt(i);
			return isPal(q);
		}           

		public static void main(String [] args){

                String s="";
                Scanner tastiera = new Scanner(System.in);

                System.out.println("Inserire una password: ");

                s = tastiera.nextLine();

		System.out.println("TEST 1:" + (test1(s) ? " ok" : " fallito"));
		System.out.println("TEST 2:" + (test2(s) ? " ok" : " fallito"));
		System.out.println("TEST 3:" + (test3(s) ? " ok" : " fallito"));
		System.out.println("TEST 4:" + (test4(s) ? " ok" : " fallito"));
        }
}
